module deriv

contains

  subroutine derx( N, fr, fi, dfr, dfi )

    implicit none
    integer :: N
    double precision, dimension (N/2) :: fr, fi, dfr, dfi
    integer :: k, kk, N2

    N2 = N/2
    do k = 1, N2
       kk = k - 1
       dfr(k) = kk * fi(k)
       dfi(k) = - kk * fr(k)
    enddo

  end subroutine derx


  subroutine derxx( N, fr, fi, d2fr, d2fi )

    implicit none
    integer :: N
    double precision, dimension (N/2) :: fr, fi, d2fr, d2fi
    integer :: k, k2, N2

    N2 = N/2
    do k = 1, N2
       k2 = ( k - 1 ) * ( k - 1 )
       d2fr(k) = - k2 * fr(k)
       d2fi(k) = - k2 * fi(k)
    enddo

  end subroutine derxx

end module deriv
